/*
** 95io.h
** If you had to ask, one of us has a problem.
** This is the header file for 95io.c so now we both know.
** Improvements are welcomed..
*/

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>

#define LF_FALSE 0
#define LF_TRUE  1
#define LF_MAXPATH 260
#define LF_MAXFILE 256

#undef MAXDIR
#define MAXDIR 67 /* DOS maxdir  */

#undef DWORD
#undef TCHAR
#undef BYTE
#define DWORD unsigned long
#define TCHAR unsigned short
#define BYTE unsigned char

#define LFINT86  int86(0x21,&lf_wreg.regs,&lf_wreg.regs)
#define LFINT86X int86x(0x21,&lf_wreg.regs,&lf_wreg.regs,&lf_wreg.sregs)

struct W95FN
{
 union REGS regs;
 struct SREGS sregs;
 };

typedef struct
{
 char fatsys[32];
 int filemax;
 int pathmax;
 unsigned lfinfo;
 }W95VOL;


/* LF findfirst/next info structs */
typedef struct _FILETIME
{
 DWORD dwLowDateTime;
 DWORD dwHighDateTime;
}FILETIME;

typedef struct _LFBLK
{
 DWORD    attrib;
 FILETIME create;
 FILETIME lastaccess;
 FILETIME lastwrite;
 DWORD    highsize;
 DWORD    lowsize;
 BYTE     Reserved[sizeof(DWORD) * 2];
 BYTE     fname[LF_MAXPATH];
 BYTE     dosname[14];
}LFBLK;


#define LF_ARCHIVE   0x00000020
#define LF_DIRECTORY 0x00000010
#define LF_HIDDEN    0x00000002
#define LF_NORMAL    0x00000080
#define LF_READONLY  0x00000001
#define LF_SYSTEM    0x00000004
#define LF_TEMPORARY 0x00000100

/*
** Reserved attribs which may come in effect later.
** Your guess is as good as mine as to what these will do.
** #define LF_ATOMIC_WRITE      0x00000200
** #define LF_XACTION_WRITE     0x00000400
*/

int LF_getosver(void);
int W95_getvol(int drive); /* good way of checking LF functionality */

int LF_getdosname(char* ,const char*);
FILE* LF_fopen(const char* ,const char* ,unsigned);
int LF_rename(const char* ,const char*);
int LF_remove(const char *);
int LF_mkdir(const char *);
int LF_chdir(const char *);
int LF_rmdir(const char *);
int LF_getcurdir(int, char*);
int LF_getname(char *, char *);
int LF_findfirst(struct _LFBLK *, char *, int *);
int LF_findnext(struct _LFBLK *, int);
int LF_findclose(int);
int LF_setattrib(char *, int);
int LF_getattrib(char *);
